define([
  'jquery',
  'Magento_Checkout/js/action/get-totals',
  'Magento_Customer/js/customer-data'
], function($, getTotalsAction, customerData) {

  $(document).ready(function() {
    var cartUpdateWait,
        productQtyElement,
        productQtyValue;

    // Plus & minus quantity buttons
    $(document).on('click', '.product-qty-plus', function() {
      productQtyElement = $(this).prev('.js-product-qty');
      productQtyValue = parseInt(productQtyElement.val());

      productQtyElement.val(productQtyValue + 1);
    });

    $(document).on('click', '.product-qty-minus', function() {
      productQtyElement = $(this).next('.js-product-qty');
      productQtyValue = parseInt(productQtyElement.val());

      if(productQtyValue > 1) {
        productQtyElement.val(productQtyValue - 1);
      }
    });

    $(document).on("change", "input[name$='[qty]']", function() {
      updateCartTotals();
    });

    // Wait 2 seconds after the last click & then update the cart
    $(document).on("click", ".js-product-qty-btn", function() {
      var time = 0;
      clearInterval(cartUpdateWait);

      cartUpdateWait = setInterval(function() {
        ++time;

        if(time >= 2) {
          updateCartTotals();
          clearInterval(cartUpdateWait);
        }
      }, 1000);
    });

    function updateCartTotals() {
      var $form = $("#form-validate");

      $.ajax({
        url: $form.attr("action"),
        data: $form.serialize(),
        showLoader: true,

        success: function(res) {
          var parsedResponse = $.parseHTML(res),
              result = $(parsedResponse).find("#form-validate"),
              sections = ["cart"],
              deferred = $.Deferred();

          $form.replaceWith(result);

          // Mini cart reloader
          customerData.reload(sections, true);

          // Totals summary reloader
          getTotalsAction([], deferred);

          var itemCount = $('.product-grid__item').data('item-count')

          $('.js-basket-count').html(itemCount)
        },

        error: function(xhr) {
          var err = eval("(" + xhr.responseText + ")");
          console.log(err.Message);
        }
      });
    }
  });
});
